
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android中用Builder模式自定义Dialog的方法_Android / iVAN</title>

    <meta name="description" content="Android中用Builder模式自定义Dialog的方法_Android 前言 我们开发人员在实际项目过程中遇到的需求是多种多样的,有时我们要匹配APP自己的设计风格,有时我们会觉得系统的对话框使用起来不够自由,因此自己定义一个适合自己的Dialog是很有必要的. 为什么要用Builder模式 Builder设计模式是一步步创建一个复杂对象的创建型模式,它允许用户在不知道内部构建细节的情况下,可以更精细地控制对象的构造流程.它的优点就在于将对象的构建和表示分离从而解耦.我们都知道Android系统自身的对话框如AlertDialog就采用了Builder模式,因此可见">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android中用Builder模式自定义Dialog的方法_Android</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>前言</strong></p>
<p>我们开发人员在实际项目过程中遇到的需求是多种多样的，有时我们要匹配APP自己的设计风格，有时我们会觉得系统的对话框使用起来不够自由，因此自己定义一个适合自己的Dialog是很有必要的。</p>
<p><strong>为什么要用Builder模式</strong></p>
<p>Builder设计模式是一步步创建一个复杂对象的创建型模式，它允许用户在不知道内部构建细节的情况下，可以更精细地控制对象的构造流程。它的优点就在于将对象的构建和表示分离从而解耦。我们都知道Android系统自身的对话框如AlertDialog就采用了Builder模式，因此可见Builder模式很适合用来构建Dialog对象。</p>
<p>下面话不多说了，上代码。</p>
<p><strong>BaseDialog.java</strong></p>
<pre>
package com.acker.android.dialog;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;

/**
 * 自定义Dialog基类
 *
 * @author guojinyu
 */
public class BaseDialog extends Dialog {

  private TextView tvTitle;
  private TextView tvMsg;
  private ProgressBar pbLoading;
  private Button btnPositive;
  private Button btnNegative;
  private FrameLayout flCustom;
  private View.OnClickListener onDefaultClickListener = new View.OnClickListener() {

    @Override
    public void onClick(View view) {
      cancel();
    }

  };
  private View.OnClickListener onPositiveListener = onDefaultClickListener;
  private View.OnClickListener onNegativeListener = onDefaultClickListener;
  private String mTitle;
  private String mMessage;
  private String positiveText;
  private String negativeText;
  private boolean isProgressBarShow = false;
  private boolean isNegativeBtnShow = true;
  private View mView;

  private BaseDialog(Context context) {
    super(context, R.style.MyDialog);
  }

  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.dialog_base);
    flCustom = (FrameLayout) findViewById(R.id.fl_dialog_content);
    tvTitle = (TextView) findViewById(R.id.tv_title);
    pbLoading = (ProgressBar) findViewById(R.id.pb_loading);
    tvMsg = (TextView) findViewById(R.id.tv_msg);
    btnPositive = (Button) findViewById(R.id.btn_positive);
    btnNegative = (Button) findViewById(R.id.btn_negative);
  }

  /**
   * 调用完Builder类的create()方法后显示该对话框的方法
   */
  @Override
  public void show() {
    super.show();
    show(this);
  }

  private void show(BaseDialog mDialog) {
    if (!TextUtils.isEmpty(mDialog.mTitle)) {
      mDialog.tvTitle.setText(mDialog.mTitle);
    }
    if (mDialog.mView != null) {
      mDialog.flCustom.addView(mDialog.mView);
      mDialog.pbLoading.setVisibility(View.GONE);
      mDialog.tvMsg.setVisibility(View.GONE);
    } else {
      if (!TextUtils.isEmpty(mDialog.mMessage)) {
        mDialog.tvMsg.setText(mDialog.mMessage);
        mDialog.tvMsg.setVisibility(View.VISIBLE);
      }
      if (isProgressBarShow) {
        mDialog.pbLoading.setVisibility(View.VISIBLE);
        mDialog.btnPositive.setVisibility(View.GONE);
        mDialog.btnNegative.setVisibility(View.GONE);
      }
    }
    if (!mDialog.isNegativeBtnShow) {
      mDialog.btnNegative.setVisibility(View.GONE);
      LinearLayout.LayoutParams layoutParams = (LinearLayout.LayoutParams) mDialog.btnPositive
          .getLayoutParams();
      layoutParams.setMargins(150, layoutParams.topMargin, 150, layoutParams.bottomMargin);
      mDialog.btnPositive.setLayoutParams(layoutParams);
    } else {
      mDialog.btnNegative.setOnClickListener(mDialog.onNegativeListener);
      if (!TextUtils.isEmpty(mDialog.negativeText)) {
        mDialog.btnNegative.setText(mDialog.negativeText);
      }
    }
    mDialog.btnPositive.setOnClickListener(mDialog.onPositiveListener);
    if (!TextUtils.isEmpty(mDialog.positiveText)) {
      mDialog.btnPositive.setText(mDialog.positiveText);
    }
  }

  public static class Builder {

    private BaseDialog mDialog;

    public Builder(Context context) {
      mDialog = new BaseDialog(context);
    }

    /**
     * 设置对话框标题
     *
     * @param title
     */
    public Builder setTitle(String title) {
      mDialog.mTitle = title;
      return this;
    }

    /**
     * 设置对话框文本内容,如果调用了setView()方法，该项失效
     *
     * @param msg
     */
    public Builder setMessage(String msg) {
      mDialog.mMessage = msg;
      return this;
    }

    /**
     * 设置确认按钮的回调
     *
     * @param onClickListener
     */
    public Builder setPositiveButton(View.OnClickListener onClickListener) {
      mDialog.onPositiveListener = onClickListener;
      return this;
    }

    /**
     * 设置确认按钮的回调
     *
     * @param btnText,onClickListener
     */
    public Builder setPositiveButton(String btnText, View.OnClickListener onClickListener) {
      mDialog.positiveText = btnText;
      mDialog.onPositiveListener = onClickListener;
      return this;
    }

    /**
     * 设置取消按钮的回掉
     *
     * @param onClickListener
     */
    public Builder setNegativeButton(View.OnClickListener onClickListener) {
      mDialog.onNegativeListener = onClickListener;
      return this;
    }

    /**
     * 设置取消按钮的回调
     *
     * @param btnText,onClickListener
     */
    public Builder setNegativeButton(String btnText, View.OnClickListener onClickListener) {
      mDialog.negativeText = btnText;
      mDialog.onNegativeListener = onClickListener;
      return this;
    }

    /**
     * 设置手否显示ProgressBar，默认不显示
     *
     * @param isProgressBarShow
     */
    public Builder setProgressBarShow(boolean isProgressBarShow) {
      mDialog.isProgressBarShow = isProgressBarShow;
      return this;
    }

    /**
     * 设置是否显示取消按钮，默认显示
     *
     * @param isNegativeBtnShow
     */
    public Builder setNegativeBtnShow(boolean isNegativeBtnShow) {
      mDialog.isNegativeBtnShow = isNegativeBtnShow;
      return this;
    }

    /**
     * 设置自定义内容View
     *
     * @param view
     */
    public Builder setView(View view) {
      mDialog.mView = view;
      return this;
    }

    /**
     * 设置该对话框能否被Cancel掉，默认可以
     *
     * @param cancelable
     */
    public Builder setCancelable(boolean cancelable) {
      mDialog.setCancelable(cancelable);
      return this;
    }

    /**
     * 设置对话框被cancel对应的回调接口，cancel()方法被调用时才会回调该接口
     *
     * @param onCancelListener
     */
    public Builder setOnCancelListener(OnCancelListener onCancelListener) {
      mDialog.setOnCancelListener(onCancelListener);
      return this;
    }

    /**
     * 设置对话框消失对应的回调接口，一切对话框消失都会回调该接口
     *
     * @param onDismissListener
     */
    public Builder setOnDismissListener(OnDismissListener onDismissListener) {
      mDialog.setOnDismissListener(onDismissListener);
      return this;
    }

    /**
     * 通过Builder类设置完属性后构造对话框的方法
     */
    public BaseDialog create() {
      return mDialog;
    }
  }
}</pre>
<p>代码很简单，BaseDialog类内定义一些对话框要显示的控件和这些控件对应的一些属性，以及最终将所有属性填入到控件的方法<code>show()</code> 。Builder类是BaseDialog的一个内部类，其中定义了BaseDialog类的所有属性的set方法以及装配完毕后的<code>create()</code>方法。</p>
<p><strong>对应的自定义Dialog的布局文件 dialog_base.xml如下：</strong></p>
<pre>
&lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
  android:layout_width="match_parent"
  android:layout_height="wrap_content"
  android:layout_marginLeft="20dp"
  android:layout_marginRight="20dp"
  android:background="@drawable/bg_base_dialog"
  android:orientation="vertical"&gt;

  &lt;TextView
    android:id="@+id/tv_title"
    android:layout_width="match_parent"
    android:layout_height="wrap_content"
    android:layout_marginBottom="10dp"
    android:layout_marginTop="10dp"
    android:gravity="center"
    android:textColor="@android:color/black"
    android:textSize="18sp" /&gt;

  &lt;View
    android:layout_width="match_parent"
    android:layout_height="1dp"
    android:background="@android:color/black" /&gt;

  &lt;LinearLayout
    android:layout_width="match_parent"
    android:layout_height="wrap_content"
    android:layout_marginLeft="20dp"
    android:layout_marginRight="20dp"
    android:orientation="horizontal"&gt;

    &lt;ProgressBar
      android:id="@+id/pb_loading"
      android:layout_width="wrap_content"
      android:layout_height="match_parent"
      android:layout_gravity="center"
      android:layout_marginBottom="20dp"
      android:layout_marginRight="20dp"
      android:layout_marginTop="20dp"
      android:visibility="gone" /&gt;

    &lt;TextView
      android:id="@+id/tv_msg"
      android:layout_width="match_parent"
      android:layout_height="wrap_content"
      android:layout_gravity="center"
      android:layout_marginBottom="20dp"
      android:layout_marginTop="20dp"
      android:textColor="@android:color/black"
      android:textSize="18sp"
      android:visibility="gone" /&gt;
  &lt;/LinearLayout&gt;

  &lt;FrameLayout
    android:id="@+id/fl_dialog_content"
    android:layout_width="match_parent"
    android:layout_height="wrap_content"&gt;&lt;/FrameLayout&gt;

  &lt;LinearLayout
    android:layout_width="match_parent"
    android:layout_height="wrap_content"
    android:orientation="horizontal"&gt;

    &lt;Button
      android:id="@+id/btn_negative"
      android:layout_width="0dp"
      android:layout_height="40dp"
      android:layout_marginBottom="20dp"
      android:layout_marginLeft="20dp"
      android:layout_marginRight="20dp"
      android:layout_weight="1"
      android:background="@drawable/bg_dialog_btn_negative"
      android:gravity="center"
      android:text="取消"
      android:textColor="@android:color/white"
      android:textSize="18sp" /&gt;

    &lt;Button
      android:id="@+id/btn_positive"
      android:layout_width="0dp"
      android:layout_height="40dp"
      android:layout_marginBottom="20dp"
      android:layout_marginLeft="20dp"
      android:layout_marginRight="20dp"
      android:layout_weight="1"
      android:background="@drawable/bg_dialog_btn_positive"
      android:gravity="center"
      android:text="确定"
      android:textColor="@android:color/white"
      android:textSize="18sp" /&gt;
  &lt;/LinearLayout&gt;

&lt;/LinearLayout&gt;</pre>
<p>涉及到的其他资源文件如下：</p>
<p><strong>对话框样式 styles.xml</strong></p>
<pre>
&lt;resources&gt;
  &lt;!-- 全局Dialog样式 --&gt;
  &lt;style name="MyDialog" parent="@android:style/Theme.Dialog"&gt;
    &lt;item name="android:windowBackground"&gt;@android:color/transparent&lt;/item&gt;
    &lt;item name="android:windowFrame"&gt;@null&lt;/item&gt;
    &lt;item name="android:windowNoTitle"&gt;true&lt;/item&gt;
    &lt;item name="android:windowIsFloating"&gt;true&lt;/item&gt;
    &lt;item name="android:windowIsTranslucent"&gt;true&lt;/item&gt;
    &lt;item name="android:background"&gt;@android:color/transparent&lt;/item&gt;
    &lt;item name="android:backgroundDimEnabled"&gt;true&lt;/item&gt;
  &lt;/style&gt;
&lt;/resources&gt;</pre>
<p>通过设置这些属性可以保证对话框背景透明无黑边。</p>
<p><strong>确定取消按钮的颜色值 colors.xml</strong></p>
<pre>
&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;resources&gt;
  &lt;color name="btn_dialog_negative_normal"&gt;#ff0000&lt;/color&gt;
  &lt;color name="btn_dialog_negative_pressed"&gt;#bf0000&lt;/color&gt;
  &lt;color name="btn_dialog_positive_normal"&gt;#368bff&lt;/color&gt;
  &lt;color name="btn_dialog_positive_pressed"&gt;#0067f3&lt;/color&gt;
&lt;/resources&gt;</pre>
<p><strong>对话框背景 bg_base_dialog.xml</strong></p>
<pre>
&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;shape xmlns:android="http://schemas.android.com/apk/res/android"
 android:shape="rectangle"&gt;
 &lt;corners android:radius="4dp" /&gt;
 &lt;solid android:color="@android:color/white" /&gt;
 &lt;stroke
   android:width="1dp"
   android:color="#e5e7ea" /&gt;
&lt;/shape&gt;</pre>
<p>包含背景、圆角、阴影效果。</p>
<p><strong>确定按钮背景 bg_dialog_btn_positive.xml</strong></p>
<pre>
&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;selector xmlns:android="http://schemas.android.com/apk/res/android"&gt;
  &lt;item android:drawable="@color/btn_dialog_positive_normal" android:state_pressed="false"&gt;&lt;/item&gt;
  &lt;item android:drawable="@color/btn_dialog_positive_pressed" android:state_pressed="true"&gt;&lt;/item&gt;
&lt;/selector&gt;</pre>
<p>包含正常和按下的效果。</p>
<p><strong>取消按钮背景 bg_dialog_btn_negative.xml</strong></p>
<pre>
&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;selector xmlns:android="http://schemas.android.com/apk/res/android"&gt;
  &lt;item android:drawable="@color/btn_dialog_negative_normal" android:state_pressed="false"&gt;&lt;/item&gt;
  &lt;item android:drawable="@color/btn_dialog_negative_pressed" android:state_pressed="true"&gt;&lt;/item&gt;
&lt;/selector&gt;</pre>
<p>包含正常和按下的效果。</p>
<p>以上就是整个自定义Dialog的所有内容，接下来我们通过一个简单的Demo来演示如何使用它。</p>
<p><strong>MainActivity.java</strong></p>
<pre>
package com.acker.android.dialog;

import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {

  BaseDialog dialog;

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);
    dialog = new BaseDialog.Builder(this).setTitle("标题").setMessage("内容")
        .setPositiveButton("哈哈", new View.OnClickListener() {
          @Override
          public void onClick(View view) {
            dialog.dismiss();
          }
        }).setOnCancelListener(new DialogInterface.OnCancelListener() {
          @Override
          public void onCancel(DialogInterface dialogInterface) {
            Toast.makeText(MainActivity.this, "cancel", Toast.LENGTH_SHORT).show();
          }
        }).setOnDismissListener(new DialogInterface.OnDismissListener() {
          @Override
          public void onDismiss(DialogInterface dialogInterface) {
            Toast.makeText(MainActivity.this, "dismiss", Toast.LENGTH_SHORT).show();
          }
        }).create();
    dialog.show();
  }

}</pre>
<p><strong>来看下效果图：</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA0OTU2NTM0ODgucG5n.jpg"></p>
<p>很丑有木有，不过没关系，这里我们只是展示它的用法，如何把对话框做的好看一点就看各位的发挥了。可以看出自定义的BaseDialog的使用方法与Andorid自身的AlertDialog基本一致，都是通过其Builder类进行对象的构建。</p>
<p>该自定义对话框还支持显示ProgressBar以及自定义内容填充的功能。</p>
<p><strong>显示ProgressBar且触摸屏幕不可取消：</strong></p>
<pre>
.setProgressBarShow(true)
.setCancelable(false)</pre>
<p><strong>效果图如下：</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA0OTU3NTIyNzEucG5n.jpg"></p>
<p><strong>自定义内容区域且不显示取消按钮：<br /></strong></p>
<pre>
View view = getLayoutInflater().inflate(R.layout.dialog_input_amount, null);
final EditText amountEdit = (EditText) view.findViewById(R.id.dialog_et_amount);
amountEdit.setText("123456789");</pre>
<pre>
.setView(view)
.setNegativeBtnShow(false)</pre>
<p><strong>其对应的布局文件为 dialog_input_amount.xml：</strong></p>
<pre>
&lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
  android:layout_width="match_parent"
  android:layout_height="wrap_content"
  android:orientation="vertical" &gt;

  &lt;EditText
    android:id="@+id/dialog_et_amount"
    android:layout_width="match_parent"
    android:layout_height="40dp"
    android:layout_marginBottom="20dp"
    android:layout_marginLeft="20dp"
    android:layout_marginRight="20dp"
    android:layout_marginTop="20dp"
    android:gravity="center_vertical"
    android:paddingLeft="10dp"
    android:paddingRight="10dp"
    android:inputType="numberDecimal"
    android:singleLine="true"
    android:textSize="18sp" &gt;
  &lt;/EditText&gt;

&lt;/LinearLayout&gt;</pre>
<p><strong>效果图如下：</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA0OTU5MjE2NzEucG5n.jpg"></p>
<p><strong>总结</strong></p>
<p>通过本文可以看出通过Builder模式自定义Dialog既可以维持原有Android对话框的使用方法，同时使用方便，自由度更高，大家完全可以按照各自的需求来对代码作出相应的修改。需要说明的是本文并没有严格按照传统的Builder设计模式来实现对话框，而是做了一些简化以更适合于我们的场景。以上就是本文的全部内容了，希望这篇文章的内容对各位Android开发者们能有所帮助。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索android<br />
                    ，                自定义dialog<br />
                                    builder模式<br />
                                    android 自定义dialog、android builder模式、alertdialog.builder、dialog.builder、customdialog.builder，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 14:30:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/builder%e6%a8%a1%e5%bc%8f/" title="builder模式">builder模式</a>, <a href="https://www.iamivan.net/tag/%e8%87%aa%e5%ae%9a%e4%b9%89dialog/" title="自定义dialog">自定义dialog</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android中用Builder模式自定义Dialog的方法_Android的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY4nDVb.html" rel="bookmark">Android中用Builder模式自定义Dialog的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 我们开发人员在实际项目过程中遇到的需求是多种多样的,有时我们要匹配APP自己的设计风格,有时我们会觉得系统的对话框使用起来不够自由,因此自己定义一个适合自己的Dialog是很有必要的. 为什么要用Builder模式 Builder设计模式是一步步创建一个复杂对象的创建型模式,它允许用户在不知道内部构建细节的情况下,可以更精细地控制对象的构造流程.它的优点就在于将对象的构建和表示分离从而解耦.我们都知道Android系统自身的对话框如AlertDialog就采用了Builder模式,因此可见			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGrPnkp.html" rel="bookmark">Android中用onSaveInstanceState保存Fragment状态的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Fragment里面,利用onSaveInstanceState保存数据,并可在onActivityCreated里面恢复数据. public void onActivityCreated(Bundle savedInstanceState) { super.onActivityCreated(savedInstanceState); ... if (savedInstanceState != null) { // Restore the fragment's state here } } p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4kKEqp.html" rel="bookmark">Android 实现夜间模式的快速简单方法实例详解&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ChangeMode 项目地址:ChangeMode Implementation of night mode for Android. 用最简单的方式实现夜间模式,支持ListView.RecyclerView. Preview Usage xml android:background=&quot;?attr/zzbackground&quot; app:backgroundAttr=&quot;zzbackground&quot;//如果当前页面要立即刷新,这里传入属性名称 比如 R.attr.zzb			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Ml0EEDM.html" rel="bookmark">Android 实现夜间模式的快速简单方法实例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ChangeMode 项目地址:ChangeMode Implementation of night mode for Android. 用最简单的方式实现夜间模式,支持ListView.RecyclerView. Preview Usage xml android:background=&quot;?attr/zzbackground&quot; app:backgroundAttr=&quot;zzbackground&quot;//如果当前页面要立即刷新,这里传入属性名称 比如 R.attr.zzb			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmX28p.html" rel="bookmark">Android布局&mdash;&mdash;Preference自定义layout的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导语:PreferenceActivity是一个方便设置管理的界面,但是对于界面显示来说比较单调,所以自定义布局就很有必要了.本文举例说明在Preference中自定义layout的方法.笔者是为了在设置中插入@有米v4广告条才研究了一晚上的. 正文:首先PreferenceScreen是一个xml文件于res/xml目录下,不属于layout文件.要插入layout,有两种方法. 1.使用Preference的android:@layout属性 1)xml文件中preference的添加 复制			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPl1E0p.html" rel="bookmark">Android编程中自定义dialog用法实例&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android编程中自定义dialog用法.分享给大家供大家参考,具体如下: dialog是android中提供的一组弹出提示框,非常好用,可是它的样式是一个定式,有时候我们需求定义一些自己的样式 1.定义一个样式文件,此文件继承自Theme.Dialog,在style.xml文件中建立一个自己的样式 &lt;style name=&quot;addNoteType_error_Dialog&quot; parent=&quot;@android:Theme.Dialog&quot;&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Nvm9b.html" rel="bookmark">android自定义组件实现方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了android自定义组件实现方法.分享给大家供大家参考.具体如下: atts.xml: &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt; &lt;resources&gt; &lt;declare-styleable name=&quot;TopBar&quot;&gt; &lt;attr name=&quot;titleText&quot; format=&quot;string&quot;/&gt; &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/badwPNz.html" rel="bookmark">Android提高篇之自定义dialog实现processDialog&OpenCurlyDoubleQuote;正在加载&rdquo;效果、使用Animation实现图片旋转</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://blog.csdn.net/tigoss/article/details/6932393  知识点: 1.使用imageview.textview自定义dialog 2.使用Animation实现图片旋转动画效果 3.通过自定义theme去掉dialog的title   没有使用progressdialog,使用起来更加灵活,请大家参考.     效果如下图:       下载地址:http://download.csdn.net/detail/tigoss/3751705 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYJk6b.html" rel="bookmark">Android实现无标题栏全屏的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android中实现全屏.无标题栏的两种办法,另附Android系统自带样式的解释 实现全屏无标题栏: 1.在xml文件中进行配置 AndroidManifest.xml中,找到需要全屏或设置成无标题栏的Activity,在该Activity进行如下配置即可. 实现全屏效果: android:theme=&quot;@android:style/Theme.NoTitleBar.Fullscreen&quot;   实现无标题栏(但有系统自带的任务栏): android:theme=&quot;@andr			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwLDvb.html" rel="bookmark" class="title">从小米盒子看高清播放器市场</a>
					<div>
						11月14日小米公司正式发布电视机顶盒小米盒子.小米盒子采用安卓4.0系统,最高支持1080P高清输出,公开售价399元,凭借399元的价格和能够打通小米手机/iOS平台的AirPlay视频分享功能这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMryVxb.html" rel="bookmark" class="title">设计点评：www&period;kontidom&period;ru</a>
					<div>
						dom|设计 Контидом www.kontidom.ru ［.ru 是俄罗斯联邦的域名］ 序今天在网上看到一个非常不错的网站,还是FLASH的网站.一开始我打开网址一看也没有什么特别的地方,后来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpmngaz.html" rel="bookmark" class="title">JavaScript极速狂飙：大容量字符型数组的快速检索</a>
					<div>
						javascript|数组     JavaScript 在大容量数组的循环方面效率不尽人意,我曾经做过一个比对,与VBS的数组相比较,VBS的数组循环速度大致比JS要快一个数量级.JS数组在一般的编 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6kN6z.html" rel="bookmark" class="title">创造完美网站布局的20个步骤</a>
					<div>
						  @设计派小温 在这篇文章中,Claudio Guglieri将为你详细解读网页布局设计的全过程. 在我们开始讨论有关网页布局的主题之前,我首先想到了我在多年的设计生涯中看到过的一些常见错误,特别是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwrrdp.html" rel="bookmark" class="title">网络故障分析排除大全</a>
					<div>
						现在家庭宽带用户已成为宽带用户的主流.宽带连接过程中,我们经常会碰到这样.那样的网络故障,如何应付呢?今天,我们就针对一些常见的网络故障给大家分析一下!希望对您的生活和娱乐能有所帮助! 1.故障现象: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badaKXz.html" rel="bookmark" class="title">JS删除字符串中重复字符方法</a>
					<div>
						 这篇文章主要介绍了JS如何删除字符串中重复字符,需要的朋友可以参考下  代码如下: &lt;!DOCTYPE html&gt;  &lt;html&gt;  &lt;head&gt;  &lt;sc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdwAaM.html" rel="bookmark" class="title">Win8系统&OpenCurlyDoubleQuote;保存截图&rdquo;功能怎么正确使用</a>
					<div>
						  截图是操作电脑中比较常用的功能,而截图的功能有很多方式,比如win7 64位旗舰版截图软件.系统自带截图功能等等,在windows8系统中其实可以在应用商店中下载&quot;保存截图&quot;工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYL2ZM.html" rel="bookmark" class="title">稻草人定时提醒与快捷工具</a>
					<div>
						  稻草人是一款聚合优质软件的便民工具,具有多种热门网站.闹钟定时等优点,全新轻量引擎.在线音乐.优化电脑.截图高清画面.记事本.除此之外,稻草人便民工具还拥有时间提醒功能,这对于忙碌的白领一族非常有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaeORM.html" rel="bookmark" class="title">如果只有一个方法还有必要用委托么？</a>
					<div>
						问题描述 如果只有一个方法还有必要用委托么? 在委托这个地方卡了很久,在网上也看了很多文章,基本上都是说的委托的语法,偶尔有介绍使用场景,但是还是一直没弄明白,总有点迷迷糊糊的,做技术就应该吧问题搞的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWdArp.html" rel="bookmark" class="title">jQuery的Ajax用户认证和注册技术实例教程&lpar;附demo源码&rpar;&lowbar;jquery</a>
					<div>
						前面介绍了&lt;jquery+ajax注册实时验证&gt;及&lt;jQuery使用$.ajax进行即时验证的方法&gt;.这里进一步总结了jQuery的Ajax用户认证和注册技术.分享给大家供大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqqkGb.html" rel="bookmark" class="title">sql-SQL2014安装失败怎么解决</a>
					<div>
						问题描述 SQL2014安装失败怎么解决 标题: Microsoft SQL Server 2014 安装程序 出现以下错误: 错误 1406.未能将值 VisualStudio.html.10.0  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkw7oop.html" rel="bookmark" class="title">Ubuntu智能手机操作系统内置云计算服务</a>
					<div>
						据国外http://www.aliyun.com/zixun/aggregation/31646.html&quot;&gt;媒体报道,Ubuntu昨天通过网络视频演示了正在开发中的智能手机操作系统. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmEK0z.html" rel="bookmark" class="title">用JavaMelody来监控我们的web应用</a>
					<div>
						   可以在 http://code.google.com/p/javamelody/downloads/list 下载它,最新的版本发布在https://github.com/javamelody/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6Dawz.html" rel="bookmark" class="title">基于用户细分的比较分析来分析网站</a>
					<div>
						细分是用于比较的,比较是为了反映差异进而做出调整优化的,所以细分的目的最终还是指导运营决策,这个才是数据分析的价值体现.从网站的用户层面,我们根据用户访问的行为特征将用户细分成各种类型,因为用户行为各 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Ygd3M.html" rel="bookmark" class="title">XSS攻击的解决方法</a>
					<div>
						在我上一篇&lt;前端安全之XSS攻击&gt;文中,并没有把XSS攻击的解决办法说完整,而XSS的攻击又那么五花八门,有没有一招&quot;独孤九剑&quot;能够抗衡,毕竟那么多情况场景,开发人员无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZENgqp.html" rel="bookmark" class="title">MFC设置窗体背景图片（画刷） &period;</a>
					<div>
						from:http://blog.csdn.net/leolee82/article/details/6992626   先载入一张图片,ID为IDB_BITMAP2 TestDlg.h中:CBrus ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NryAM.html" rel="bookmark" class="title">数据库-关于BIRT开发报表的流程问题</a>
					<div>
						问题描述 关于BIRT开发报表的流程问题 刚接触报表这个东西.今天导师要求用eclipse的birt开发一个报表.过程大概是这样:在一个页面输入一个条件 然后在数据库中检索出符合条件的结果 生成一个表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7NKOz.html" rel="bookmark" class="title">关于Android Studio2&period;0 集成 百度云push的问题，导入so包还能怎么导入</a>
					<div>
						问题描述 关于Android Studio2.0 集成 百度云push的问题,导入so包还能怎么导入 Eclipse 可以推送 ,在AndroidStudio上集成的问题 估计是so包导入的不对 ,但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjYvPM.html" rel="bookmark" class="title">xcode-在Xcode中编辑xib导致Xcode闪退问题</a>
					<div>
						问题描述 在Xcode中编辑xib导致Xcode闪退问题 http://www.cocoachina.com/bbs/read.php?tid=333056# 解决方案 是不是xcode的问题.xco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRVJOb.html" rel="bookmark" class="title">跟踪G-Sensor有时不起作用的问题</a>
					<div>
						跟踪G-Sensor有时不起作用的问题        最近在生产反馈中,有提到批量机器中有大约2%的机器遇到不转屏的问题.笔者通过反复跟踪,重现了这个问题,通过分析lsmod,看到驱动又已经加载,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A65Zz.html" rel="bookmark" class="title">苹果专利战不败神话遭终结 微软发难Android再添烦恼</a>
					<div>
						在专利诉讼上频频告捷的苹果,这次尝到了失败的滋味.   日前,在德国曼海姆地方法院,摩托罗拉移动就苹果侵犯其两项专利发起诉讼并获得胜诉.经过法院裁决,只要摩托罗拉移动每年拿出一亿欧元的保证金,便可立即 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40o4Jz.html" rel="bookmark" class="title">段错误-在ubuntu环境下执行python程序，报错 segment error</a>
					<div>
						问题描述 在ubuntu环境下执行python程序,报错 segment error 请教各位朋友们,应该如何查看出错的代码文件和行数呢,只报错segment error,无法知道程序哪里错了.而且程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKyjjb.html" rel="bookmark" class="title">分享python数据统计的一些小技巧&lowbar;python</a>
					<div>
						最近在用python做数据统计,这里总结了一些最近使用时查找和总结的一些小技巧,希望能帮助在做这方面时的一些童鞋.有些技巧是很平常的用法,平时我们没有注意,但是在特定场景,这些小方法还是能带来很大的帮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXr76z.html" rel="bookmark" class="title">程序员辞职转做淘宝客，月入3万秒杀上班族</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 一个程序员,一次偶然的机会在测试一个项目的时候接触到淘宝客,发现比上班赚钱快的多,于是兼职做淘宝客,没想到做着做着做大了:在辉煌的时候,一个月进账3万, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/pnKW20z.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vbW1iaXoucXBpYy5jbi9tbWJpei93YzdZTlBtM1l4WERWRWhxeDBBeWVqMTlPY0NLbEZaVFliYkJHUU1Fc0Z6WE45VVdCRmliOHJocFBQaWNVazZnRms4cXZBblQ1R0ZWN3BsY0V1ZGRmTGFRLzA=.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/pnKW20z.html" rel="bookmark" class="title">&lbrack;译&rsqb;人工智能带给我们的恐惧</a>
					<div>
						几年以前我和一个刚刚创业的朋友品茶小聚,他刚过不惑之年却饱受背伤之苦,父亲也疾病缠身,一切痛楚让他觉得被生活所拖累,尝尽命运捉弄之苦.&quot;不怕你笑话&quot;,他提到,我现在真是&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAZZEb.html" rel="bookmark" class="title">使用WebDriver过程中遇到的那些问题</a>
					<div>
						在做web项目的自动化端到端测试时主要使用的是Selenium WebDriver来驱动浏览器.Selenium WebDriver的优点是支持的语言多,支持的浏览器多.主流的浏览器Chrome.Fi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7N0Kz.html" rel="bookmark" class="title">How to Copy ASM Files Across Nodes &lbrack;ID 1147859&period;1&rsqb;</a>
					<div>
						  How to Copy ASM Files Across Nodes [ID 1147859.1] ------------------------------------------------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0n9O7z.html" rel="bookmark" class="title">NS2仿真</a>
					<div>
						1.建立脚本文件(只给出两个关键点的代码) 配置模拟属性: set val(chan)  Channel/WirelessChannel   ;# 信道类型 set val(prop) Propaga ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJQeqp.html" rel="bookmark" class="title">《深入实践Spring Boot》一1&period;4　运行与发布</a>
					<div>
						1.4 运行与发布 本章实例工程的完整代码可以使用IDEA直接从GitHub的https://github.com/chen-fromsz/spring-boot-hello.git中检出,如图1-1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QOx4M.html" rel="bookmark" class="title">关于java金字塔内部掏空的</a>
					<div>
						问题描述 关于java金字塔内部掏空的 public class taokong{ public static void main(String [] args){ int lay=7;//表示有多少 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
